#!/usr/bin/python
## -*- utf-8 -*-

import logging
log = logging.getLogger(__name__) 
from util import *
import communication
import random

##############################################################################
##

class Game(object):
  
  def __init__(self, gameMode):
      self.reset()
  
  def reset(self):
      self.pattern = []
      self.pattern_index = 0
      self.pattern_correct = 0

  
  def setComm(self,comm):
      self._comm = comm
      
  def setGui(self, gui):
      self._gui = gui

  def gameThread(self):
      #disable keys
      #initRound
      self.pattern_index = 0
      
      #self.disableButtons()
      #play pattern
      #self.threadRunning = 1
      self.playPattern()
         
      #while self.threadRunning == 1:
         # pass
      #enable keys
      #self.enableButtons()
      #loop until enough notes
      #    "read" one note
      #    verify
      #    show correct color
      #ask for new note  #failure -> game ends
      #increase score
      #add user selected note to pattern
      #            send pattern to opponent
      #add random note to pattern  #opponent chooses a new note   #opponent mistake-->game ends
      #LOOPBACK
      
      
      pass
      
  def playPattern(self):
      self._gui.runSequenceThread(self.pattern)
      #self._gui.playSequence(self.pattern)
      pass
  
  def verifyPattern(self, note):
      if self.pattern[self.pattern_index] == note :
        print "note correct"
        if len(self.pattern) == self.pattern_index+1:
          print "end of pattern"
          return 2
        else :
          self.pattern_index = self.pattern_index + 1
          print "pattern continues"
          return 1
      else :
          print "note incorrect"
          return 0 

  def addRandomNote(self):
      self.addNote(self.randomNote())
  
  def randomNote(self):
      note = random.randrange(5)
      print note
      return note
  
  
  def addNote(self, note):
      self.pattern.append(note)
      print note
      print self.pattern
      self.pattern_index = 0
      self.pattern.append(self.randomNote())
      print self.pattern
      self.gameThread()
  
  def disableButtons(self):
    self._gui.disableButtons("True")
      
  def enableButtons(self):
    self._gui.disableButtons("False")  
 
  def startGame(self):
    self.gameThread()

##############################################################################
##

if __name__ == '__main__':
  logging.basicConfig(level=logging.DEBUG)
  #comm = communication.Comm()
  #game = Game(comm)
  #comm.set_ind(game)
